"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("@nodeswork/utils");
const UNKOWN_METHOD_ERROR = new utils_1.NodesworkError('unkown method').toJSON();
function socketRpcHost(socket, target, eventNamePrefix) {
    socket.on(`${eventNamePrefix}.request`, async (request) => {
        const fn = target[request.name];
        let result;
        let error;
        let resp;
        if (fn == null) {
            error = UNKOWN_METHOD_ERROR;
        }
        else {
            try {
                result = await fn.apply(target, request.args);
            }
            catch (e) {
                error = utils_1.NodesworkError.cast(e).toJSON({ cause: true });
            }
        }
        const response = {
            requestId: request.requestId,
            result,
            error,
        };
        socket.emit(request.responseEventName, response);
    });
}
exports.socketRpcHost = socketRpcHost;

//# sourceMappingURL=host.js.map
